/*
*  Copyright 2019-2020 Zheng Jie
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*  http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*/
package me.zhengjie.modules.dm.order.repository;

import me.zhengjie.modules.dm.order.domain.DmOrderItem;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;

import java.util.List;
import java.util.Map;

/**
* @website https://el-admin.vip
* @author sunmz
* @date 2021-09-15
**/
public interface DmOrderItemRepository extends JpaRepository<DmOrderItem, Long>, JpaSpecificationExecutor<DmOrderItem> {
    //最受欢迎菜品(三种)
    @Query(value = "SELECT name,SUM(num) as num FROM dm_order_item " +
            "GROUP BY pid ORDER BY num DESC LIMIT 0,3 ",nativeQuery = true)
    List<Map<String,Object>> hyFood();
}