package me.zhengjie.modules.dm.order.service.dto;

import com.alibaba.fastjson.annotation.JSONField;
import com.alibaba.fastjson.serializer.ToStringSerializer;
import lombok.Data;
import me.zhengjie.modules.dm.food.domain.DmFood;
import me.zhengjie.modules.dm.order.domain.DmOrderItem;
import me.zhengjie.modules.system.domain.Dept;

import java.io.Serializable;
import java.sql.Timestamp;

@Data
public class DmExpenseCalendar implements Serializable {
    /** 防止精度丢失 */
    @JSONField(serializeUsing = ToStringSerializer.class)
    private Long id;

    private DmOrderItem orderItem;

    //实付金额
    private String money;
    private String orderItemMoney;

    //用户唯一识别号
    private String mob;

    //用户工号
    private String userCode;

    //用户姓名
    private String userName;

    //用户部门
    private Long deptId;

    //人员种类
    private String userType;

    //用户手机号
    private String phone;

    //下单时间
    private Timestamp createDate;

    //合计金额
    private String totalMoney;

    //折扣
    private String zkMoney;

    //流水号
    private Long seq;
    private Long orderItemSeq;

    //卡id
    private String card;

    //卡no
    private String cardNo;

    private Integer cardProfile;

    //餐别 1-早餐,2-午餐,3-晚餐,4-夜宵
    private Integer part;

    //终端id
    private Integer term;

    //餐厅id
    private Integer shop;

    //终端名称
    private String termName;

    //餐厅名称
    private String shopName;

    //金额
    private Double amt;
    private Double orderItemAmt;

    //卡余额
    private Double balance;

    //账户类型 0-主账户、1-补贴账户
    private Integer account;

    //支付类型 11-主账户、21-补贴账户、 2-现金、 3-银联、30-扫码支付、31-微信、32-支付宝
    private Integer type;

    private String tel;

    /** 防止精度丢失 */
//    @JSONField(serializeUsing = ToStringSerializer.class)
    private Long orderItemId;

    private String pjType;

    /** 编号 */
    private String bh;
    private String orderItemBh;

    /** 商品编号 */
    private DmFood food;

    private Long pid;

    private String code;

    /** 商品名称 */
    private String name;

    /** 单价 */
    private String price;

    /** 数量 */
    private Integer num;
}
