/*
*  Copyright 2019-2020 Zheng Jie
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*  http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*/
package me.zhengjie.modules.dm.serveEvaluate.domain;

import lombok.Data;
import cn.hutool.core.bean.BeanUtil;
import io.swagger.annotations.ApiModelProperty;
import cn.hutool.core.bean.copier.CopyOptions;
import me.zhengjie.base.BaseEntity;

import javax.persistence.*;
import javax.validation.constraints.*;
import java.sql.Timestamp;
import java.io.Serializable;

/**
* @website https://el-admin.vip
* @description /
* @author xwx
* @date 2021-04-20
**/
@Entity
@Data
@Table(name="dm_serve_evaluate")
public class DmServeEvaluate  extends BaseEntity implements Serializable {

    @Id
    @Column(name = "id")
    @ApiModelProperty(value = "主键")
    private Long id;

    @Column(name = "food_name")
    @ApiModelProperty(value = "菜品名称")
    private String foodName;

    @Column(name = "concat")
    @ApiModelProperty(value = "评价详情(对菜品的评价内容)")
    private String concat;

    @Column(name = "request_user")
    @ApiModelProperty(value = "用户名称(评价的用户名称)")
    private String requestUser;

    @Column(name = "order_time")
    @ApiModelProperty(value = "点餐时间(用户点餐时间）")
    private Timestamp orderTime;

    @Column(name = "evaluate_time")
    @ApiModelProperty(value = "评价时间(用户评价时间)")
    private Timestamp evaluateTime;

    public void copy(DmServeEvaluate source){
        BeanUtil.copyProperties(source,this, CopyOptions.create().setIgnoreNullValue(true));
    }
}